/[gentoo-x86]/eclass/distutils.eclass
Gentoo

Diff of /eclass/distutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.4 Revision 1.71
1# Copyright 2002 Gentoo Technologies, Inc. 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/distutils.eclass,v 1.71 2010/02/07 21:17:15 pva Exp $
4
5# @ECLASS: distutils.eclass
6# @MAINTAINER:
7# Gentoo Python Project <python@gentoo.org>
8#
3# Author: Jon Nelson <jnelson@gentoo.org> 9# Original author: Jon Nelson <jnelson@gentoo.org>
4# $Header: /var/cvsroot/gentoo-x86/eclass/distutils.eclass,v 1.4 2002/10/25 19:55:52 vapier Exp $ 10# @BLURB: Eclass for packages with build systems using Distutils
5# The distutils eclass is designed to allow easier installation of 11# @DESCRIPTION:
6# distutils-based python modules, and their incorporation into 12# The distutils eclass defines phase functions for packages with build systems using Distutils
7# the Gentoo Linux system.
8 13
9ECLASS=distutils 14inherit eutils multilib python
10INHERITED="$INHERITED $ECLASS"
11 15
12EXPORT_FUNCTIONS src_compile src_install 16case "${EAPI:-0}" in
17 0|1)
18 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm
19 ;;
20 *)
21 EXPORT_FUNCTIONS src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm
22 ;;
23esac
13 24
14newdepend "virtual/python" 25if [[ -z "${PYTHON_DEPEND}" ]]; then
26 DEPEND="virtual/python"
27 RDEPEND="${DEPEND}"
28fi
15 29
30if has "${EAPI:-0}" 0 1 2; then
31 python="python"
32else
33 # Use "$(PYTHON)" or "$(PYTHON -A)" instead of "${python}".
34 python="die"
35fi
36
37# @ECLASS-VARIABLE: DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES
38# @DESCRIPTION:
39# Set this to use separate source directories for each enabled version of Python.
40
41# @ECLASS-VARIABLE: DISTUTILS_GLOBAL_OPTIONS
42# @DESCRIPTION:
43# Global options passed to setup.py.
44
45# @ECLASS-VARIABLE: DISTUTILS_SRC_TEST
46# @DESCRIPTION:
47# Type of test command used by distutils_src_test().
48# IUSE and DEPEND are automatically adjusted, unless DISTUTILS_DISABLE_TEST_DEPENDENCY is set.
49# Valid values:
50# setup.py
51# nosetests
52# py.test
53# trial [arguments]
54
55# @ECLASS-VARIABLE: DISTUTILS_DISABLE_TEST_DEPENDENCY
56# @DESCRIPTION:
57# Disable modification of IUSE and DEPEND caused by setting of DISTUTILS_SRC_TEST.
58
59if [[ -n "${DISTUTILS_SRC_TEST}" && ! "${DISTUTILS_SRC_TEST}" =~ ^(setup\.py|nosetests|py\.test|trial(\ .*)?)$ ]]; then
60 die "'DISTUTILS_SRC_TEST' variable has unsupported value '${DISTUTILS_SRC_TEST}'"
61fi
62
63if [[ -z "${DISTUTILS_DISABLE_TEST_DEPENDENCY}" ]]; then
64 if [[ "${DISTUTILS_SRC_TEST}" == "nosetests" ]]; then
65 IUSE="test"
66 DEPEND+="${DEPEND:+ }test? ( dev-python/nose )"
67 elif [[ "${DISTUTILS_SRC_TEST}" == "py.test" ]]; then
68 IUSE="test"
69 DEPEND+="${DEPEND:+ }test? ( dev-python/py )"
70 # trial requires an argument, which is usually equal to "${PN}".
71 elif [[ "${DISTUTILS_SRC_TEST}" =~ ^trial(\ .*)?$ ]]; then
72 IUSE="test"
73 DEPEND+="${DEPEND:+ }test? ( dev-python/twisted )"
74 fi
75fi
76
77if [[ -n "${DISTUTILS_SRC_TEST}" ]]; then
78 EXPORT_FUNCTIONS src_test
79fi
80
81# @ECLASS-VARIABLE: DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS
82# @DESCRIPTION:
83# Set this to disable renaming of Python scripts containing versioned shebangs
84# and generation of wrapper scripts.
85
86# @ECLASS-VARIABLE: DOCS
87# @DESCRIPTION:
88# Additional documentation files installed by distutils_src_install().
89
90_distutils_get_build_dir() {
91 if [[ -n "${SUPPORT_PYTHON_ABIS}" && -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
92 echo "build-${PYTHON_ABI}"
93 else
94 echo "build"
95 fi
96}
97
98_distutils_get_PYTHONPATH() {
99 if [[ -n "${SUPPORT_PYTHON_ABIS}" && -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
100 ls -d build-${PYTHON_ABI}/lib* 2> /dev/null
101 else
102 ls -d build/lib* 2> /dev/null
103 fi
104}
105
106_distutils_hook() {
107 if [[ "$#" -ne 1 ]]; then
108 die "${FUNCNAME}() requires 1 argument"
109 fi
110 if [[ "$(type -t "distutils_src_${EBUILD_PHASE}_$1_hook")" == "function" ]]; then
111 "distutils_src_${EBUILD_PHASE}_$1_hook"
112 fi
113}
114
115# @FUNCTION: distutils_src_unpack
116# @DESCRIPTION:
117# The distutils src_unpack function. This function is exported.
118distutils_src_unpack() {
119 if [[ "${EBUILD_PHASE}" != "unpack" ]]; then
120 die "${FUNCNAME}() can be used only in src_unpack() phase"
121 fi
122
123 unpack ${A}
124 cd "${S}"
125
126 has "${EAPI:-0}" 0 1 && distutils_src_prepare
127}
128
129# @FUNCTION: distutils_src_prepare
130# @DESCRIPTION:
131# The distutils src_prepare function. This function is exported.
132distutils_src_prepare() {
133 if ! has "${EAPI:-0}" 0 1 && [[ "${EBUILD_PHASE}" != "prepare" ]]; then
134 die "${FUNCNAME}() can be used only in src_prepare() phase"
135 fi
136
137 # Delete ez_setup files to prevent packages from installing Setuptools on their own.
138 local ez_setup_existence="0"
139 [[ -d ez_setup || -f ez_setup.py ]] && ez_setup_existence="1"
140 rm -fr ez_setup*
141 if [[ "${ez_setup_existence}" == "1" ]]; then
142 echo "def use_setuptools(*args, **kwargs): pass" > ez_setup.py
143 fi
144
145 # Delete distribute_setup files to prevent packages from installing Distribute on their own.
146 local distribute_setup_existence="0"
147 [[ -d distribute_setup || -f distribute_setup.py ]] && distribute_setup_existence="1"
148 rm -fr distribute_setup*
149 if [[ "${distribute_setup_existence}" == "1" ]]; then
150 echo "def use_setuptools(*args, **kwargs): pass" > distribute_setup.py
151 fi
152
153 if [[ -n "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
154 python_copy_sources
155 fi
156}
157
158# @FUNCTION: distutils_src_compile
159# @DESCRIPTION:
160# The distutils src_compile function. This function is exported.
161# In ebuilds of packages supporting installation for multiple versions of Python, this function
162# calls distutils_src_compile_pre_hook() and distutils_src_compile_post_hook(), if they are defined.
16distutils_src_compile() { 163distutils_src_compile() {
17 python setup.py build || die "compilation failed" 164 if [[ "${EBUILD_PHASE}" != "compile" ]]; then
18} 165 die "${FUNCNAME}() can be used only in src_compile() phase"
166 fi
19 167
168 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
169 distutils_building() {
170 _distutils_hook pre
171
172 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "$(_distutils_get_build_dir)" "$@"
173 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "$(_distutils_get_build_dir)" "$@" || return "$?"
174
175 _distutils_hook post
176 }
177 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_building "$@"
178 else
179 echo "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@"
180 "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" || die "Building failed"
181 fi
182}
183
184# @FUNCTION: distutils_src_test
185# @DESCRIPTION:
186# The distutils src_test function. This function is exported, when DISTUTILS_SRC_TEST variable is set.
187distutils_src_test() {
188 if [[ "${DISTUTILS_SRC_TEST}" == "setup.py" ]]; then
189 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
190 distutils_testing() {
191 echo PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") test "$@"
192 PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") test "$@"
193 }
194 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_testing "$@"
195 else
196 echo PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" test "$@" || die "Testing failed"
197 PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" test "$@" || die "Testing failed"
198 fi
199 elif [[ "${DISTUTILS_SRC_TEST}" == "nosetests" ]]; then
200 python_execute_nosetests -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- "$@"
201 elif [[ "${DISTUTILS_SRC_TEST}" == "py.test" ]]; then
202 python_execute_py.test -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- "$@"
203 # trial requires an argument, which is usually equal to "${PN}".
204 elif [[ "${DISTUTILS_SRC_TEST}" =~ ^trial(\ .*)?$ ]]; then
205 local trial_arguments
206 if [[ "${DISTUTILS_SRC_TEST}" == "trial "* ]]; then
207 trial_arguments="${DISTUTILS_SRC_TEST#trial }"
208 else
209 trial_arguments="${PN}"
210 fi
211
212 python_execute_trial -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- ${trial_arguments} "$@"
213 else
214 die "'DISTUTILS_SRC_TEST' variable has unsupported value '${DISTUTILS_SRC_TEST}'"
215 fi
216}
217
218# @FUNCTION: distutils_src_install
219# @DESCRIPTION:
220# The distutils src_install function. This function is exported.
221# In ebuilds of packages supporting installation for multiple versions of Python, this function
222# calls distutils_src_install_pre_hook() and distutils_src_install_post_hook(), if they are defined.
223# It also installs some standard documentation files (AUTHORS, Change*, CHANGELOG, CONTRIBUTORS,
224# KNOWN_BUGS, MAINTAINERS, MANIFEST*, NEWS, PKG-INFO, README*, TODO).
20distutils_src_install() { 225distutils_src_install() {
21 python setup.py install --root=${D} || die 226 if [[ "${EBUILD_PHASE}" != "install" ]]; then
22 dodoc CHANGELOG COPYRIGHT KNOWN_BUGS MAINTAINERS 227 die "${FUNCNAME}() can be used only in src_install() phase"
23 dodoc CONTRIBUTORS LICENSE COPYING* 228 fi
24 dodoc Change* MANIFEST* README* ${mydoc} 229
230 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
231 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
232 declare -A wrapper_scripts=()
233
234 rename_scripts_with_versioned_shebangs() {
235 if [[ -d "${D}usr/bin" ]]; then
236 cd "${D}usr/bin"
237
238 local file
239 for file in *; do
240 if [[ -f "${file}" && ! "${file}" =~ [[:digit:]]+\.[[:digit:]]+$ && "$(head -n1 "${file}")" =~ ^'#!'.*python[[:digit:]]+\.[[:digit:]]+ ]]; then
241 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
242 wrapper_scripts+=(["${D}usr/bin/${file}"]=)
243 fi
244 done
245 fi
246 }
247 fi
248
249 distutils_installation() {
250 _distutils_hook pre
251
252 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") install --root="${D}" --no-compile "$@"
253 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") install --root="${D}" --no-compile "$@" || return "$?"
254
255 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
256 rename_scripts_with_versioned_shebangs
257 fi
258
259 _distutils_hook post
260 }
261 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_installation "$@"
262
263 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${#wrapper_scripts[@]}" -ne 0 && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
264 python_generate_wrapper_scripts "${!wrapper_scripts[@]}"
265 fi
266 unset wrapper_scripts
267 else
268 # Mark the package to be rebuilt after a Python upgrade.
269 python_need_rebuild
270
271 echo "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@"
272 "$(PYTHON -A)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" || die "Installation failed"
273 fi
274
275 if [[ -e "${D}usr/local" ]]; then
276 die "Illegal installation into /usr/local"
277 fi
278
279 local default_docs
280 default_docs="AUTHORS Change* CHANGELOG CONTRIBUTORS KNOWN_BUGS MAINTAINERS MANIFEST* NEWS PKG-INFO README* TODO"
281
282 local doc
283 for doc in ${default_docs}; do
284 [[ -s "${doc}" ]] && dodoc "${doc}"
285 done
286
287 if [[ -n "${DOCS}" ]]; then
288 dodoc ${DOCS} || die "dodoc failed"
289 fi
25} 290}
291
292# @FUNCTION: distutils_pkg_postinst
293# @DESCRIPTION:
294# The distutils pkg_postinst function. This function is exported.
295# When PYTHON_MODNAME variable is set, then this function calls python_mod_optimize() with modules
296# specified in PYTHON_MODNAME variable. Otherwise it calls python_mod_optimize() with module, whose
297# name is equal to name of current package, if this module exists.
298distutils_pkg_postinst() {
299 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
300 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
301 fi
302
303 local pylibdir pymod
304 if [[ -z "${PYTHON_MODNAME}" ]]; then
305 for pylibdir in "${ROOT}"/usr/$(get_libdir)/python*; do
306 if [[ -d "${pylibdir}/site-packages/${PN}" ]]; then
307 PYTHON_MODNAME="${PN}"
308 fi
309 done
310 fi
311
312 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
313 python_mod_optimize ${PYTHON_MODNAME}
314 else
315 for pymod in ${PYTHON_MODNAME}; do
316 python_mod_optimize "$(python_get_sitedir)/${pymod}"
317 done
318 fi
319}
320
321# @FUNCTION: distutils_pkg_postrm
322# @DESCRIPTION:
323# The distutils pkg_postrm function. This function is exported.
324# When PYTHON_MODNAME variable is set, then this function calls python_mod_cleanup() with modules
325# specified in PYTHON_MODNAME variable. Otherwise it calls python_mod_cleanup() with module, whose
326# name is equal to name of current package, if this module exists.
327distutils_pkg_postrm() {
328 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
329 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
330 fi
331
332 local pylibdir pymod
333 if [[ -z "${PYTHON_MODNAME}" ]]; then
334 for pylibdir in "${ROOT}"/usr/$(get_libdir)/python*; do
335 if [[ -d "${pylibdir}/site-packages/${PN}" ]]; then
336 PYTHON_MODNAME="${PN}"
337 fi
338 done
339 fi
340
341 if [[ -n "${PYTHON_MODNAME}" ]]; then
342 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
343 python_mod_cleanup ${PYTHON_MODNAME}
344 else
345 for pymod in ${PYTHON_MODNAME}; do
346 for pylibdir in "${ROOT}"/usr/$(get_libdir)/python*; do
347 if [[ -d "${pylibdir}/site-packages/${pymod}" ]]; then
348 python_mod_cleanup "${pylibdir#${ROOT}}/site-packages/${pymod}"
349 fi
350 done
351 done
352 fi
353 else
354 python_mod_cleanup
355 fi
356}
357
358# @FUNCTION: distutils_python_version
359# @DESCRIPTION:
360# Deprecated wrapper function for deprecated python_version().
361distutils_python_version() {
362 if ! has "${EAPI:-0}" 0 1 2; then
363 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
364 die "${FUNCNAME}() cannot be used in this EAPI"
365 fi
366
367 python_version
368}
369
370# @FUNCTION: distutils_python_tkinter
371# @DESCRIPTION:
372# Deprecated wrapper function for python_tkinter_exists().
373distutils_python_tkinter() {
374 if ! has "${EAPI:-0}" 0 1 2; then
375 eerror "Use python_tkinter_exists() instead of ${FUNCNAME}()."
376 die "${FUNCNAME}() cannot be used in this EAPI"
377 fi
378
379 python_tkinter_exists
380}

Legend:
Removed from v.1.4  
changed lines
  Added in v.1.71

  ViewVC Help
Powered by ViewVC 1.1.20